#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define M 6
#define N 6

void v_add(int *v1, int *v2, int n)
{
	int i;

	for (i = 0; i < n; i++)
		v1[i] += v2[i];
}

void v_show(int *v, int n)
{
	int i;

	for (i = 0; i < n; i++)
		printf("%3d ", v[i]);	
	printf("\n");
}

double prob_r(int *y, int *z, int n)
{
	int i;	
	double r;

	r = 1;
	for (i = 0; i < n; i++)
		if (z[i] == 1) {
			r /= (y[i] + 1);
		} else if (z[i] == -1) {
			r *= y[i];
		}
	return r;
}

int main(int argc, char *argv[])
{
	int i, j;
	int seed = 0;
	int n = 10000;
	int burnin = n;
	double r;
	double rr;
	int markov_b[M][N] = {
		{0,-1, 1, 0, 1,-1}, 
		{1,-1, 0,-1, 1, 0},
		{1, 0,-1,-1, 0, 1},
		{0, 1,-1, 0,-1, 1}, 
		{-1, 1, 0, 1,-1, 0},
		{-1, 0, 1, 1, 0,-1}
	};
	int state[N] = {0,5,0,5,0,10};
	double sum = 0.0;

	if (argc >= 2) {
		seed = atoi(argv[1]);	
	} 
	if (argc >= 3) {
		n = atoi(argv[2]);	
	} 
	if (argc >= 4) {
		burnin = atoi(argv[3]);
	}

	srand(seed);

	/* burn-in */
	for (i = 0; i < burnin; i++) {
		j = (int)(M * (rand()/(RAND_MAX + 1.0)));
		r = prob_r(state, markov_b[j], N);	
		rr = (double)rand()/RAND_MAX;	
		if (r > rr)
			v_add(state, markov_b[j], N);
	}

	for (i = 0; i < n; i++) {
		sum += 2*state[0]+state[1];
		j = (int)(M * (rand()/(RAND_MAX + 1.0)));
		r = prob_r(state, markov_b[j], N);	
		rr = (double)rand()/RAND_MAX;	
		if (r > rr)
			v_add(state, markov_b[j], N);
		v_show(state, N);
	}

	printf("ave : %lf\n", sum/n);

	return 0;
}
