l <- matrix(nrow = 8, ncol = 3)
l[1,] <- c(-1,-1,-1)
l[2,] <- c(-1,-1, 1)
l[3,] <- c(-1, 1,-1)
l[4,] <- c(-1, 1, 1)
l[5,] <- c( 1,-1,-1)
l[6,] <- c( 1,-1, 1)
l[7,] <- c( 1, 1,-1)
l[8,] <- c( 1, 1, 1)

get_index <- function(v) {
	for (i in 1:nrow(l)) {
		if (all(l[i,] == v)) {
			return(i)
		}
	}
	return(0)
}

test_get_index <- function() {
	v <- c(1,-1,-1)
	print(get_index(v))
	v <- c(1,1,-1)
	print(get_index(v))
	v <- c(2,1,-1)
	print(get_index(v))
}

myp <- function(x, t = 0.2) {
	return(exp(t * (x[1]*x[2] + x[2]*x[3] + x[1]*x[3])))
}

nz <- function(t = 0.2) {
	return(2.0*exp(3.0*t) + 6.0*exp(-t))
}

# 引数
# n : 取り出すサンプル数
# x : 初期値
metropolis <- function(n = 10000, x = c(-1,-1,-1)) {
	select <- sample(c(1:3), n, replace=TRUE) # どの index (1 or 2 or 3) を選ぶか
	rr <- runif(n)
	h <- c(0,0,0,0,0,0,0,0)                   # 各状態がいくつ得られたかを格納
	# result <- list()                        # 得られたサンプルを格納 
	for (i in 1:n) {	
		index <- select[i]
		xx <- x
		xx[index] <- -xx[index]
		r <- myp(xx)/myp(x)
		if (r > rr[i]) {
			x <- xx
		}
		print(x)
		ind <- get_index(x)
		h[ind] <- h[ind] + 1
		# result <- append(result, list(x))
	}
	print(h)
	barplot(h)

	p <- numeric(8)                     # 理論値
	for (i in 1:8) {
		p[i] <- myp(l[i,])/nz()
	}
	pp <- h/n                           # 実験値
	cat("実験値\n")
	print(pp)
	cat("理論値\n")
	print(p)
}

cat("metropolis(サンプル数, 初期値) で実行\n") 
cat("e.g. metropolis(10000, c(-1,-1,-1))\n") 

